import API from '@/services'

export default ({ moduleName = '', serviceName = '', serviceArguments = {} }) => {
    const {method, endpoint} = API[moduleName][serviceName]
    const urlBase = endpoint
    const { body, query, headers } = getQueryStringAndHeaders(serviceArguments)
    let url, options
    if(method == 'POST') {
        url = urlBase
        options = {headers, method, body}
    }
    if(method == 'GET') {
        url = `${urlBase}?${query}`
        options = {headers, method}
    }

    return {
        url,
        options
    }
}

// 后续可换成 query-string npm 包
function getQueryStringAndHeaders(serviceArguments) {
    let { headers, body, query } = serviceArguments
    headers = headers ? headers : {
        'Content-Type': 'application/json',
        'mode': 'cors'
    }
    body = JSON.stringify(body ? body : {})
    query = query ? Object.keys(query).reduce((pre, key) => `${pre}&${key}=${query[key]}`, '').slice(1) : ''
    return {headers, body, query}
}