import { XHR } from '@/http/axios'

// 导出同构mutation映射器
export const mapMutations = MAP => Object.keys(MAP).reduce((pre, serviceName) => {
  pre[serviceName] = (state, data) => {
    state[MAP[serviceName]] = data
  }
  return pre
}, {})

// 导出同构action映射器 (api)
export const mapActions = (moduleName, API) => API.reduce((pre, serviceName) => {
  pre[serviceName] = ({commit}, serviceArguments) => {
    return XHR[`${moduleName}/${serviceName}`](serviceArguments)
  }
  return pre
}, {})