import FETCH from '@/http/fetch'

// 导出同构mutation映射器
export const mapMutations = MAP => Object.keys(MAP).reduce((pre, serviceName) => {
  pre[serviceName] = (state, data) => {
    state[MAP[serviceName]] = data
  }
  return pre
}, {})

// 导出同构action映射器 (api)
export const mapActions = (moduleName, API) => API.reduce((pre, serviceName) => {
  pre[serviceName] = ({commit}, serviceArguments) => {
    // SERVICE['user/search']
    return FETCH[`${moduleName}/${serviceName}`](serviceArguments).then(res => {
      // commit(serviceName, res.data)
      if(res.code === 200) {
        return {
          ok: true,
          playload: res
        }
      }
      // 响应归一化：非正常响应和各种错误
      return {
        ok: false,
        playload: res
      }
    })
  }
  return pre
}, {})